/*
 * NormalizeRegistry.cpp
 *
 *  Created on: 21. 8. 2017
 *	  Author: Jan Travnicek
 */

#include <registry/NormalizeRegistry.hpp>

namespace abstraction {

ext::map < std::string, std::list < std::unique_ptr < NormalizeRegistry::Entry > > > & NormalizeRegistry::getEntries ( ) {
	static ext::map < std::string, std::list < std::unique_ptr < Entry > > > entries;
	return entries;
}

std::shared_ptr < abstraction::OperationAbstraction > NormalizeRegistry::getAbstraction ( const std::string & param ) {
	auto res = getEntries ( ).find ( param );
	if ( res == getEntries ( ).end ( ) || res->second.size ( ) == 0 )
		throw std::invalid_argument ( "Entry " + param + " not available." );

	return res->second.front( )->getAbstraction ( );
}

bool NormalizeRegistry::hasNormalize ( const std::string & param ) {
	auto res = getEntries ( ).find ( param );
	return res != getEntries ( ).end ( ) && res->second.size ( ) > 0;
}

} /* namespace abstraction */
